#include <bits/stdc++.h>

using namespace std;

int mat[10000][10000];
int n,m,k,a,b,i,j,br;



void boji(int x, int y)
{
    mat[x][y]=br;
    if(x+1<=n&&mat[x+1][y]==0)
        boji(x+1,y);
    if(x-1>0&&mat[x-1][y]==0)
        boji(x-1,y);
    if(y+1<=m&&mat[x][y+1]==0)
        boji(x,y+1);
    if(y-1>0&&mat[x][y-1]==0)
        boji(x,y-1);
}


int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin>>n>>m>>k;
    
    for(i=0;i<k;i++)
    {
        cin>>a>>b;
        mat[a][b]=-1;
    }
    
    br=0;
    
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=m;j++)
            {
                if(mat[i][j]==0)
                {
                    br++;
                    boji(i,j);
                }
            }
    }
    
    cout<<br;
    
    return 0;
}